
local min,max in math

local function clamp(value, min_value, max_value)
  return max(min(value, max_value), min_value)
end

function ShipProperty.shield_regen_rate(ship)
  local regenerators=0

  for s in systems(ship)
    if (s.type == 'shield_regenerator') and (s.damage < .5*s.health)
      regenerators++
    end
  end

  -- more or less fair?
  return 0.1 * (1 + min(regenerators, 5))
end